package com.dreamcodex.ti.util;

import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.image.ImageFilter;
import java.awt.image.RGBImageFilter;
import java.util.Arrays;
import java.util.Comparator;

public class Globals {
    public static final String CMD_NEW = "new";
    public static final String CMD_OPEN = "open";
    public static final String CMD_SAVE = "save";
    public static final String CMD_SAVEAS = "saveas";
    public static final String CMD_APPEND = "append";
    public static final String CMD_EXIT = "exit";
    public static final String CMD_MPIMGMN = "importimagemono";
    public static final String CMD_MPIMGCL = "importimagecolor";
    public static final String CMD_MPCIMGMN = "importcharimagemono";
    public static final String CMD_MPCIMGCL = "importcharimagecolor";
    public static final String CMD_MPMAPIMG = "importmapimage";
    public static final String CMD_MPVDP = "importvramdump";
    public static final String CMD_XPDATA = "exportdata";
    public static final String CMD_XPEXEC = "exportexec";
    public static final String CMD_XPASM = "exportasm";
    public static final String CMD_XPBIN = "exportbin";
    public static final String CMD_XPBINMAP = "exportbinmap";
    public static final String CMD_XPCIMGMN = "exportcharimagemono";
    public static final String CMD_XPCIMGCL = "exportcharimagecolor";
    public static final String CMD_XPMAPIMG = "exportmapimage";
    public static final String CMD_XPSCROLL = "exportscroll";
    public static final String CMD_GRID = "togglegrid";
    public static final String CMD_LOOK = "look";
    public static final String CMD_UNDO = "undo";
    public static final String CMD_REDO = "redo";
    public static final String CMD_CLONE = "clone";
    public static final String CMD_FILL = "fill";
    public static final String CMD_CLEAR = "clear";
    public static final String CMD_ROTATEL = "rotatel";
    public static final String CMD_ROTATER = "rotater";
    public static final String CMD_FLIPH = "fliph";
    public static final String CMD_FLIPV = "flipv";
    public static final String CMD_SHIFTU = "shiftu";
    public static final String CMD_SHIFTD = "shiftd";
    public static final String CMD_SHIFTL = "shiftl";
    public static final String CMD_SHIFTR = "shiftr";
    public static final String CMD_INVERT = "invert";
    public static final String CMD_EDITCHR = "editchar";
    public static final String CMD_UPDATE = "update";
    public static final String CMD_COPY = "copy";
    public static final String CMD_PASTE = "paste";
    public static final String CMD_CLRFORE = "clrfore";
    public static final String CMD_CLRBACK = "clrback";
    public static final String CMD_CLRCHOOSE = "clrchoose";
    public static final String CMD_PALSELECT = "palselect";
    public static final String CMD_ADDMAP = "addmap";
    public static final String CMD_DELMAP = "delmap";
    public static final String CMD_PREVMAP = "prevmap";
    public static final String CMD_NEXTMAP = "nextmap";
    public static final String CMD_BACKMAP = "backmap";
    public static final String CMD_FORWMAP = "forwmap";
    public static final String CMD_TCURSOR = "textcursor";
    public static final String CMD_SHOWPOS = "toggleshowpos";
    public static final String CMD_BASE0POS = "base0position";
    public static final String CMD_XPXBDISMER = "screenMerge";
    public static final String CMD_LOADDEFS = "loaddefaultchars";
    public static final String CMD_CHARTOOL = "togglechartool";
    public static final String CMD_SWAPCHARS = "swapcharacters";
    public static final String CMD_ANALYZECHARTRANS = "analyzechartrans";
    public static final String CMD_MODESET = "changemode";
    public static final String CMD_GRAPHICSCOLORMODE = "graphicscolormode";
    public static final String CMD_BITMAPCOLORMODE = "bitmapcolormode";
    public static final String CMD_ECM2COLORMODE = "ecm2colormode";
    public static final String CMD_ECM3COLORMODE = "ecm3colormode";
    public static final String CMD_TRANSPARENCY = "transparency";
    public static final String CMD_ABOUT = "helpabout";

    public static final String KEY_SCRBACK = "SB:"; // phasing out
    public static final String KEY_COLOR_MODE = "CM:";
    public static final String KEY_COLORSET = "CC:";
    public static final String KEY_PALETTE = "PL:"; // Color palette  (ECM)
    public static final String KEY_CHARPALS = "CP:"; // Char palettes (ECM)
    public static final String KEY_CHARDATA = "CH:";
    public static final String KEY_CHARDATA1 = "C1:"; // Char data plane 1 (ECM)
    public static final String KEY_CHARDATA2 = "C2:"; // Char data plane 2 (ECM)
    public static final String KEY_CHARCOLOR = "CO:";
    public static final String KEY_CHARRANG = "CR:"; // needed temporarily until all mag files are new format
    public static final String KEY_MAPCOUNT = "MC:";
    public static final String KEY_MAPSTART = "M+";
    public static final String KEY_MAPSIZE = "MS:";
    public static final String KEY_MAPBACK = "MB:";
    public static final String KEY_MAPDATA = "MP:";
    public static final String KEY_MAPEND = "M-";

    public static final Color CLR_COMPONENTBACK = new Color(255, 255, 255);
    public static final Color CLR_BUTTON_NORMAL = new Color(255, 255, 255);
    public static final Color CLR_BUTTON_ACTIVE = new Color(232, 212, 255);
    public static final Color CLR_BUTTON_INACTIVE = new Color(96, 96, 96);
    public static final Color CLR_BUTTON_TRANS = new Color(232, 232, 192);
    public static final Color CLR_BUTTON_SHIFT = new Color(192, 255, 232);

    public static final int INDEX_CLR_BACK = 0;
    public static final int INDEX_CLR_FORE = 1;

    public static final int INDEX_SPR_UL = 0;
    public static final int INDEX_SPR_UR = 1;
    public static final int INDEX_SPR_LL = 2;
    public static final int INDEX_SPR_LR = 3;

    public static final int MASK_HIBITS = 240;
    public static final int MASK_LOBITS = 15;

    public static Dimension DM_TOOL = new Dimension(24, 24);
    public static Dimension DM_TEXT = new Dimension(48, 24);

    public static Border bordButtonNormal = BorderFactory.createLineBorder(new Color(164, 164, 164), 2);
    public static Border bordButtonActive = BorderFactory.createLineBorder(new Color(255, 164, 164), 2);

    public static final String BLANKCHAR = "0000000000000000";

    public static String padHexString(String s, int length) {
        if (s == null) {
            s = "";
        }
        if (s.length() < length) {
            while (s.length() < length) {
                s += "0";
            }
        }
        else if (s.length() > length) {
            s = s.substring(0, length);
        }
        return s;
    }

    public static String getByteString(int[][] binarray) {
        return getByteString(binarray, 1);
    }

    public static String getByteString(int[][] binarray, int mask) {
        StringBuffer sbBytes = new StringBuffer();
        int bytepos = 0;
        int byteval = 0;
        int charrow = (binarray.length / 8);
        int charcol = (binarray[0].length / 8);
        for (int cc = 0; cc < charcol; cc++) {
            for (int cr = 0; cr < charrow; cr++) {
                for (int y = 0; y < 8; y++) {
                    int cy = y + (cr * 8);
                    bytepos = 0;
                    for (int x = 0; x < 8; x++) {
                        int cx = x + (cc * 8);
                        if ((binarray[cy][cx] & mask) > 0) {
                            byteval += 8 >> bytepos;
                        }
                        bytepos++;
                        if (bytepos > 3) {
                            sbBytes.append(Integer.toHexString(byteval));
                            byteval = 0;
                            bytepos = 0;
                        }
                    }
                    if (bytepos != 0) {
                        sbBytes.append(Integer.toHexString(byteval));
                        byteval = 0;
                    }
                }
            }
        }
        return sbBytes.toString();
    }

    public static String getColorHexString(int[][] colorGrid) {
        StringBuilder hex = new StringBuilder();
        for (int[] row : colorGrid) {
            hex.append(Integer.toHexString(row[1]));
            hex.append(Integer.toHexString(row[0]));
        }
        return hex.toString();
    }

    public static int[][] parseColorHexString(String hex) {
        int[][] charColors = new int[8][2];
        for (int y = 0; y < 8; y++) {
            charColors[y][1] = Integer.parseInt(Character.toString(hex.charAt(y * 2)), 16);
            charColors[y][0] = Integer.parseInt(Character.toString(hex.charAt(y * 2 + 1)), 16);
        }
        return charColors;
    }

    public static int[][] getByteIntArray(String sbtyes, int rows) {
        int charcol = (sbtyes.length() / rows) * 4;
        int[][] barray = new int[rows][charcol];
        int charpos = 0;
        int rowpos = 0;
        int colpos = 0;
        for (int cc = 0; cc < sbtyes.length(); cc++) {
            String ch = "" + sbtyes.charAt(cc);
            int chi = Integer.parseInt(ch, 16);
            barray[rowpos][charpos + colpos] = (((chi & 8) == 8) ? 1 : 0);
            charpos++;
            barray[rowpos][charpos + colpos] = (((chi & 4) == 4) ? 1 : 0);
            charpos++;
            barray[rowpos][charpos + colpos] = (((chi & 2) == 2) ? 1 : 0);
            charpos++;
            barray[rowpos][charpos + colpos] = (((chi & 1) == 1) ? 1 : 0);
            charpos++;
            if (charpos >= 8) {
                charpos = 0;
                rowpos++;
                if (rowpos >= rows) {
                    rowpos = 0;
                    colpos += 8;
                }
            }
        }
        return barray;
    }

    public static int[][] flipGrid(int[][] grid, boolean isVertical) {
        int height = grid.length;
        int width = grid[0].length;
        int flipx = 0;
        int flipy = 0;
        int[][] flippedGrid = new int[height][width];
        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                if (isVertical) {
                    flipx = x;
                    flipy = (height - 1) - y;
                }
                else {
                    flipx = (width - 1) - x;
                    flipy = y;
                }
                flippedGrid[flipy][flipx] = grid[y][x];
            }
        }
        grid = flippedGrid;
        return grid;
    }

    public static int[][] rotateGrid(int[][] grid, boolean isLeft) {
        int height = grid.length;
        int width = grid[0].length;
        int rotx = 0;
        int roty = 0;
        int[][] rotatedGrid = new int[width][height];
        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                if (isLeft) {
                    rotx = y;
                    roty = (height - 1) - x;
                }
                else {
                    rotx = (width - 1) - y;
                    roty = x;
                }
                rotatedGrid[roty][rotx] = grid[y][x];
            }
        }
        grid = rotatedGrid;
        return grid;
    }

    public static int[][] invertGrid(int[][] grid, int maxValue) {
        int height = grid.length;
        int width = grid[0].length;
        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                grid[y][x] = maxValue - grid[y][x];
            }
        }
        return grid;
    }

    public static int[][] shiftGrid(int[][] grid, int xshift, int yshift) {
        int y = (yshift < 0 ? grid.length - 1 : 0);
        while (y >= 0 && y <= (grid.length - 1)) {
            int getY = y + yshift;
            int x = (xshift < 0 ? grid[y].length - 1 : 0);
            while (x >= 0 && x <= (grid[y].length - 1)) {
                int getX = x + xshift;
                if (getY >= 0 && getY < grid.length && getX >= 0 && getX < grid[y].length) {
                    grid[y][x] = grid[getY][getX];
                }
                else {
                    grid[y][x] = 0;
                }
                x = x + (xshift < 0 ? -1 : 1);
            }
            y = y + (yshift < 0 ? -1 : 1);
        }
        return grid;
    }

    public static int[][] cycleGridLeft(int[][] grid) {
        for (int[] row : grid) {
            int temp = row[0];
            System.arraycopy(row, 1, row, 0, row.length - 1);
            row[row.length - 1] = temp;
        }
        return grid;
    }

    public static int[][] cycleGridRight(int[][] grid) {
        for (int[] row : grid) {
            int temp = row[row.length - 1];
            System.arraycopy(row, 0, row, 1, row.length - 1);
            row[0] = temp;
        }
        return grid;
    }

    public static int[][] cycleGridUp(int[][] grid) {
        int[] tempRow = grid[0];
        System.arraycopy(grid, 1, grid, 0, grid.length - 1);
        grid[grid.length - 1] = tempRow;
        return grid;
    }

    public static int[][] cycleGridDown(int[][] grid) {
        int[] tempRow = grid[grid.length - 1];
        System.arraycopy(grid, 0, grid, 1, grid.length - 1);
        grid[0] = tempRow;
        return grid;
    }

    public static void copyGrid(int[][] grid, int[][] destination, int xPos, int yPos) {
        for (int y = 0; y < grid.length; y++) {
            int[] row = grid[y];
            System.arraycopy(grid[y], 0, destination[y + yPos], xPos, row.length);
        }
    }

    public static void orGrid(int[][] sourceGrid, int[][] destGrid, int shift) {
        for (int y = 0; y < sourceGrid.length; y++) {
            for (int x = 0; x < sourceGrid[0].length; x++) {
                destGrid[y][x] |= sourceGrid[y][x] << shift;
            }
        }
    }

    public static boolean gridEquals(int[][] sourceGrid, int[][] destGrid) {
        for (int y = 0; y < sourceGrid.length; y++) {
            for (int x = 0; x < sourceGrid[0].length; x++) {
                if (destGrid[y][x] != sourceGrid[y][x]) {
                    return false;
                }
            }
        }
        return true;
    }

    public static void sortGrid(int[][] grid) {
        Arrays.sort(grid, new Comparator<int[]>() {
            public int compare(int[] a1, int[] a2) {
                return a2[1] - a1[1];
            }
        });
    }

    public static void printGrid(int[][] grid) {
        for (int[] row : grid) {
            for (int x = 0; x < row.length; x++) {
                System.out.print(row[x] + (x < row.length - 1 ? "," : "\n"));
            }
        }
        System.out.println();
    }

    public static boolean arrayContains(int[][] grid, int value) {
        for (int[] row : grid) {
            if (arrayContains(row, value)) {
                return true;
            }
        }
        return false;
    }

    public static boolean arrayContains(int[] row, int value) {
        for (int cell : row) {
            if (cell == value) {
                return true;
            }
        }
        return false;
    }

    public static ImageFilter ifTrans = new RGBImageFilter() {
        public int tagTrans = TIGlobals.TI_COLOR_TRANSOPAQUE.getRGB();

        public final int filterRGB(int x, int y, int rgb) {
            if (rgb == tagTrans) {
                return 0x00000000;
            }
            return rgb;
        }
    };

    public static String toHexString(int n, int length) {
        String value = Integer.toHexString(n).toUpperCase();
        while (value.length() < length) {
            value = "0" + value;
        }
        return value;
    }

    public static boolean isColorGridEmpty(int[][] grid) {
        if (grid != null) {
            for (int[] row : grid) {
                if (row[0] != 0 || row[1] != 0) { // 0 = Transparent
                    return false;
                }
            }
        }
        return true;
    }

    public static boolean isColorTransitionOK(int foreColor1, int foreColor2, int backColor1, int backColor2, int screenColor, int[][] charGrid1, int[][] charGrid2) {
        return
                ((foreColor1 != 0 ? foreColor1 : screenColor) == (foreColor2 != 0 ? foreColor2 : screenColor) ||
                        !arrayContains(charGrid1, INDEX_CLR_FORE) || !arrayContains(charGrid2, INDEX_CLR_FORE)) &&
                        ((backColor1 != 0 ? backColor1 : screenColor) == (backColor2 != 0 ? backColor2 : screenColor) ||
                                !arrayContains(charGrid1, INDEX_CLR_BACK) || !arrayContains(charGrid2, INDEX_CLR_BACK));

    }

    public static boolean isColorTransitionOK(int foreColor1, int foreColor2, int backColor1, int backColor2, int screenColor, int[] charGrid1, int[] charGrid2) {
        return
                ((foreColor1 != 0 ? foreColor1 : screenColor) == (foreColor2 != 0 ? foreColor2 : screenColor) ||
                        !arrayContains(charGrid1, INDEX_CLR_FORE) || !arrayContains(charGrid2, INDEX_CLR_FORE)) &&
                        ((backColor1 != 0 ? backColor1 : screenColor) == (backColor2 != 0 ? backColor2 : screenColor) ||
                                !arrayContains(charGrid1, INDEX_CLR_BACK) || !arrayContains(charGrid2, INDEX_CLR_BACK));

    }

    public static Color getClosestColor(Color color, Color[] palette) {
        return palette[getClosestColorIndex(color, palette)];
    }

    public static int getClosestColorIndex(Color color, Color[] palette) {
        return getClosestColorIndex(color, palette, 0);
    }

    public static int getClosestColorIndex(Color color, Color[] palette, int excludeIndex) {
        // Find best matching color
        double minColDist = Double.MAX_VALUE;
        int colorIndex = 0;
        for (int n = 0; n < palette.length; n++) {
            if (palette[n] != null && (excludeIndex == -1 || n != excludeIndex)) {
                double dist = colorDistance(color, palette[n]);
                if (dist < minColDist) {
                    minColDist = dist;
                    colorIndex = n;
                }
            }
        }
        return colorIndex;
    }

    public static double colorDistance(int color1, int color2) {
        return colorDistance(new Color(color1), new Color(color2));
    }

    public static double colorDistance(Color c1, Color c2)
    {
///*
//        double rmean = (c1.getRed() + c2.getRed()) / 2;
//        int r = c1.getRed() - c2.getRed();
//        int g = c1.getGreen() - c2.getGreen();
//        int b = c1.getBlue() - c2.getBlue();
//        double weightR = 2 + rmean / 256;
//        double weightG = 4.0;
//        double weightB = 2 + (255 - rmean) / 256;
//        return Math.sqrt(weightR * r * r + weightG * g * g + weightB * b * b);
//*/
        return Math.sqrt(Math.pow(c1.getRed() - c2.getRed(), 2) + Math.pow(c1.getGreen() - c2.getGreen(), 2) + Math.pow(c1.getBlue() - c2.getBlue(), 2));
    }
}